# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Aug 11 12:14:36 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_audit.db.tables.cfg_key import tCfgKey
from bs_audit.db.tables.cfg import tCfg

class dCfgSelectOne:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tCfgKey()
        self.orec     = None

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        self._dbstmnt = None

    async def exec_deft(self,
                        id: str) -> "dCfgSelectOne":
        """
        Execute the query by setting all the inputs.

        :param id: str
        :return: Self for convenience.
        """
        self.irec.id = id

        return await self.exec()

    async def exec(self, irec: tCfgKey = None) -> "dCfgSelectOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("CfgSelectOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  id,
  col_pk,
  col_ignr,
  par_id,
  par_col,
  last_chg,
  audby_col,
  mode
from
  audit.Cfg
where
  id = :id""")

        self._dbstmnt.bind_in("id", self.irec.id, str)

        self._dbstmnt.bind_out("id", str)
        self._dbstmnt.bind_out("col_pk", str)
        self._dbstmnt.bind_out("col_ignr", str)
        self._dbstmnt.bind_out("par_id", str)
        self._dbstmnt.bind_out("par_col", str)
        self._dbstmnt.bind_out("last_chg", datetime.datetime)
        self._dbstmnt.bind_out("audby_col", str)
        self._dbstmnt.bind_out("mode", str, 1)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:Cfg, proc:SelectOne, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec = tCfg()

        self.orec.id = self._dbstmnt.result[0]
        self.orec.col_pk = self._dbstmnt.result[1]
        self.orec.col_ignr = self._dbstmnt.result[2]
        self.orec.par_id = self._dbstmnt.result[3]
        self.orec.par_col = self._dbstmnt.result[4]
        self.orec.last_chg = self._dbstmnt.result[5]
        self.orec.audby_col = self._dbstmnt.result[6]
        self.orec.mode = self._dbstmnt.result[7]

        return True

    async def fetch_iter(self) -> tCfg:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while await self.fetch():
            yield self.orec

    async def fetch_all(self, out_list: tCfg.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while await self.fetch():
            out_list.append(self.orec)

        return len(out_list)

